#ifndef _INLINE_MATHIEEESINGTRANS_H
#define _INLINE_MATHIEEESINGTRANS_H

#ifndef __INLINE_MACROS_H
#include <inline/macros.h>
#endif

#ifndef MATHIEEESINGTRANS_BASE_NAME
#define MATHIEEESINGTRANS_BASE_NAME MathIeeeSingTransBase
#endif

#define IEEESPAcos(parm) \
	LP1(0x78, FLOAT, IEEESPAcos, FLOAT, parm, d0, \
	, MATHIEEESINGTRANS_BASE_NAME)

#define IEEESPAsin(parm) \
	LP1(0x72, FLOAT, IEEESPAsin, FLOAT, parm, d0, \
	, MATHIEEESINGTRANS_BASE_NAME)

#define IEEESPAtan(parm) \
	LP1(0x1e, FLOAT, IEEESPAtan, FLOAT, parm, d0, \
	, MATHIEEESINGTRANS_BASE_NAME)

#define IEEESPCos(parm) \
	LP1(0x2a, FLOAT, IEEESPCos, FLOAT, parm, d0, \
	, MATHIEEESINGTRANS_BASE_NAME)

#define IEEESPCosh(parm) \
	LP1(0x42, FLOAT, IEEESPCosh, FLOAT, parm, d0, \
	, MATHIEEESINGTRANS_BASE_NAME)

#define IEEESPExp(parm) \
	LP1(0x4e, FLOAT, IEEESPExp, FLOAT, parm, d0, \
	, MATHIEEESINGTRANS_BASE_NAME)

#define IEEESPFieee(parm) \
	LP1(0x6c, FLOAT, IEEESPFieee, FLOAT, parm, d0, \
	, MATHIEEESINGTRANS_BASE_NAME)

#define IEEESPLog(parm) \
	LP1(0x54, FLOAT, IEEESPLog, FLOAT, parm, d0, \
	, MATHIEEESINGTRANS_BASE_NAME)

#define IEEESPLog10(parm) \
	LP1(0x7e, FLOAT, IEEESPLog10, FLOAT, parm, d0, \
	, MATHIEEESINGTRANS_BASE_NAME)

#define IEEESPPow(exp, arg) \
	LP2(0x5a, FLOAT, IEEESPPow, FLOAT, exp, d1, FLOAT, arg, d0, \
	, MATHIEEESINGTRANS_BASE_NAME)

#define IEEESPSin(parm) \
	LP1(0x24, FLOAT, IEEESPSin, FLOAT, parm, d0, \
	, MATHIEEESINGTRANS_BASE_NAME)

#define IEEESPSincos(cosptr, parm) \
	LP2(0x36, FLOAT, IEEESPSincos, FLOAT *, cosptr, a0, FLOAT, parm, d0, \
	, MATHIEEESINGTRANS_BASE_NAME)

#define IEEESPSinh(parm) \
	LP1(0x3c, FLOAT, IEEESPSinh, FLOAT, parm, d0, \
	, MATHIEEESINGTRANS_BASE_NAME)

#define IEEESPSqrt(parm) \
	LP1(0x60, FLOAT, IEEESPSqrt, FLOAT, parm, d0, \
	, MATHIEEESINGTRANS_BASE_NAME)

#define IEEESPTan(parm) \
	LP1(0x30, FLOAT, IEEESPTan, FLOAT, parm, d0, \
	, MATHIEEESINGTRANS_BASE_NAME)

#define IEEESPTanh(parm) \
	LP1(0x48, FLOAT, IEEESPTanh, FLOAT, parm, d0, \
	, MATHIEEESINGTRANS_BASE_NAME)

#define IEEESPTieee(parm) \
	LP1(0x66, FLOAT, IEEESPTieee, FLOAT, parm, d0, \
	, MATHIEEESINGTRANS_BASE_NAME)

#endif /* _INLINE_MATHIEEESINGTRANS_H */
